Summary: A high-performance mail store with IMAP and POP3 support.
Name: cyrus-imapd
Version: 2.2.12
Release: 3tr
License: BSD
Group: Trustix Community
URL: http://asg.web.cmu.edu/cyrus/imapd/
Source0: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/cyrus-imapd-%{version}.tar.gz
Source1: cyrus-README
Source2: cyrus-procmailrc
Source3: cyrus-deliver-wrapper.c
Source4: cyrus-user-procmailrc.template
Source8:  cyrus-imapd.conf
Source11: cyrus-imapd.cron
Source13: cyrus-imapd-master.conf
Source14: cyrus-imapd-rc
Source15: cyrus-README.autocreate-cyrus-2.2

Patch1: cyrus-imapd-2.0.5-pollute.patch
#Patch2: cyrus-imapd-2.0.5-mandir.patch

# Not applied:
Patch6: mysql+ldapauxprop.patch.gz

Patch7: cyrus-imapd-perl-path2.patch

Patch8: cyrus-imapd-2.2.3-tail.patch
#Patch9: cyrus-imapd-2.2.3-libdir.patch
Patch10: http://email.uoa.gr/download/cyrus/cyrus-imapd-2.2.10/cyrus-imapd-2.2.10-autocreate-0.9.1.diff

BuildRoot: %{_tmppath}/%{name}-root
Requires: cyrus-sasl, db4, chkconfig, tsl-utils, imapd-pam
BuildRequires: cyrus-sasl-devel, e2fsprogs-devel, perl, perl-devel, tcp_wrappers
BuildRequires: db4, db4-devel, openssl-devel 
Prereq: shadow-utils, glibc
Provides: imapd
%define mail_gid 12
%define cyrus_uid 110

%description
The Cyrus IMAP server is a scaleable enterprise mail system
designed for use from small to large enterprise environments using
standards-based technologies.

A full Cyrus IMAP implementation allows a seamless mail and bulletin
board environment to be set up across multiple servers. It differs from
other IMAP server implementations in that it is run on "sealed"
servers, where users are not normally permitted to log in. The mailbox
database is stored in parts of the filesystem that are private to the
Cyrus IMAP system. All user access to mail is through software using
the IMAP, POP3, or KPOP protocols.

%package devel
Requires: %{name} = %{version}-%{release}
Group: Trustix Official
Summary: Files needed for developing applications with Cyrus IMAPD.

%description devel
The %{name}-devel package contains files needed for developing and
compiling applications which use the Cyrus IMAPD.

%prep
%setup -q
%patch1 -p1
#%patch2 -p1
%patch7 -p1
%patch8 -p1
#%patch9 -p1
%patch10 -p1

find doc -name CVS -type d | xargs -r rm -fr
find . -type f -print0 | xargs -0 perl -pi -e 's|/etc/imapd.conf|/etc/cyrus-imapd/imapd.conf|g'

%build
CPPFLAGS="-I/usr/include/et -fPIC" 
export CPPFLAGS

# Hack around old config.sub
cat>config.sub<<__EOF__
#!/bin/bash
echo "%{_target_platform}"

__EOF__

#autoconf
%configure \
	--enable-netscapehack \
	--enable-annotatemore \
	--enable-listext \
	--with-perl=/usr/bin/perl \
	--with-libwrap \
	--with-openssl \
	--with-sasl \
	--with-com_err \
	--with-krb=no \
	--with-cyrus-prefix=%{_libdir}/%{name} \
	--sysconfdir=%{_sysconfdir}/%{name}

# Force rebuild of the files depending on this one
touch lib/imapoptions

make all
gcc $RPM_OPT_FLAGS -o deliver-wrapper $RPM_SOURCE_DIR/cyrus-deliver-wrapper.c

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
# Create directories.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/{cron.daily,postfix}
mkdir -p $RPM_BUILD_ROOT/{usr/bin,%{_sysconfdir}/sbin}
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/init.d

# Build and populate /var/spool and /var/imap.
mkdir -p -m 0755 \
 $RPM_BUILD_ROOT/var/spool/cyrus-imap/{stage,user,quota,proc,log,msg,socket,db}

# Do what the regular make install does.
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir}/cyrus,%{_libdir}}
install -d $RPM_BUILD_ROOT%{_mandir}/man{1,3,5,8}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/%{name}

eval `perl '-V:installsitearch'`

make install DESTDIR=$RPM_BUILD_ROOT \
	INSTALLSITEARCH=$installsitearch \
	PREFIX=$RPM_BUILD_ROOT%{_prefix} \
	CYRUS_USER=%{cyrus_uid} \
	CYRUS_GROUP=%{mail_gid} \
	mandir=%{_mandir}

make -C man install DESTDIR=$RPM_BUILD_ROOT \
	INSTALLSITEARCH=$installsitearch \
	PREFIX=$RPM_BUILD_ROOT%{_prefix} \
	CYRUS_USER=%{cyrus_uid} \
	CYRUS_GROUP=%{mail_gid} \
	mandir=%{_mandir}


# Install the delivery agent.
install -s deliver-wrapper \
	$RPM_BUILD_ROOT/%{_libdir}/%{name}/bin/deliver-wrapper

install -m 755 imtest/imtest $RPM_BUILD_ROOT/usr/bin/imtest
install -m 755 perl/imap/cyradm $RPM_BUILD_ROOT/usr/bin/cyradm

# Install various configuration files.
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/imapd.conf
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/procmailrc
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/user-procmailrc
install -m 755 %{SOURCE11} $RPM_BUILD_ROOT/%{_sysconfdir}/cron.daily/%{name}

touch    $RPM_BUILD_ROOT/var/spool/cyrus-imap/mailboxes
export IMAP_DIR="$RPM_BUILD_ROOT/var/spool/cyrus-imap/"
echo "IMAP_DIR: $IMAP_DIR"
for i in user quota sieve; do
  for j in a b c d e f g h i j k l m n o p q r s t u v w x y z; do
    mkdir -p -m 0755 $IMAP_DIR/$i/$j
  done
done

# Install the /etc/cyrus.conf file that controls master process
install -m 644 %{SOURCE13} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/cyrus.conf

# Install rc script
install -m 755 %{SOURCE14} $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/cyrus

# Install the tools
for tool in tools/* ; do
	test -f ${tool} && install -m755 ${tool} $RPM_BUILD_ROOT/usr/bin/
done

# Renaming the master program to aviod name collision
mv $RPM_BUILD_ROOT/usr/lib/cyrus-imapd/bin/master \
     $RPM_BUILD_ROOT/usr/lib/cyrus-imapd/bin/cyrus-master


# We need to rename the internal man pages of cyrus to avoid conflicts with
# other programs.
pushd $RPM_BUILD_ROOT/%{_mandir}/man8
for i in arbitron.8 chk_cyrus.8 collectnews.8 ctl_cyrusdb.8\
	ctl_deliver.8 ctl_mboxlist.8 deliver.8 fud.8\
	fud.8 idled.8 imapd.8 ipurge.8 lmtpd.8 master.8 mbpath.8\
	notifyd.8 pop3d.8 quota.8 reconstruct.8 rmnews.8 squatter.8\
	deliver-wrapper.8 syncnews.8 timsieved.8 tls_prune.8;do
	 if sed -e "s/$i/cyrus-$i/" $i > cyrus-$i 2>/dev/null; then
            rm $i 
         else
	    rm cyrus-$i
         fi
done
popd

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
/etc/init.d/cyrus stop 2>/dev/null >/dev/null || :
# Dynamically add the cyrus user BEFORE installing package
if [ -z "`getent group mail`" ]; then
        /usr/sbin/groupadd -g %{mail_gid} mail
fi
if [ -z "`getent passwd cyrus`" ]; then
        /usr/sbin/useradd -d /var/spool/cyrus-imap -s /bin/sh \
        -g mail -u %{cyrus_uid} cyrus
fi

%post
# force synchronous updates
# Note: This will slow down user creation for 10.000+ users!
chattr -R +S /var/spool/cyrus-imap user quota 2>/dev/null
chattr -R +S /var/spool/cyrus-imap 2>/dev/null

#install -m600 -o cyrus -g mail /dev/null /var/log/imapd.log

/sbin/chkconfig --add cyrus
/sbin/restart_maybe cyrus

echo "Don't forget to activate the mail transport to cyrus in postfix"

%preun
if [ $1 = 0 ]; then
	/etc/init.d/cyrus stop 2>/dev/null || :
	/sbin/chkconfig --del cyrus || :
fi

%postun
if [ $1 -ge 1 ]; then
	/sbin/restart_maybe cyrus 2>&1 > /dev/null
fi

%files
%defattr(-,root,root,0755)
%doc COPYRIGHT README README.autocreate doc/*
%{_sysconfdir}/cron.daily/*
%dir %{_sysconfdir}/%{name}
%config %{_sysconfdir}/%{name}/procmailrc
%config %{_sysconfdir}/%{name}/user-procmailrc
%config(noreplace) %{_sysconfdir}/%{name}/cyrus.conf
%config(noreplace) %{_sysconfdir}/%{name}/imapd.conf
%attr(0755,root,root) %{_sysconfdir}/init.d/cyrus
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/bin
%{_libdir}/%{name}/bin/arbitron
%{_libdir}/%{name}/bin/chk_cyrus
%{_libdir}/%{name}/bin/ctl_cyrusdb
%{_libdir}/%{name}/bin/ctl_deliver
%{_libdir}/%{name}/bin/ctl_mboxlist
%{_libdir}/%{name}/bin/cvt_cyrusdb
%{_libdir}/%{name}/bin/cyr_expire
%{_libdir}/%{name}/bin/cyrdump
%{_libdir}/%{name}/bin/deliver
%attr(2755,cyrus,mail) %{_libdir}/%{name}/bin/deliver-wrapper
%{_libdir}/%{name}/bin/fud
%{_libdir}/%{name}/bin/imapd
%{_libdir}/%{name}/bin/ipurge
%{_libdir}/%{name}/bin/lmtpd
%{_libdir}/%{name}/bin/cyrus-master
%{_libdir}/%{name}/bin/mbexamine
%{_libdir}/%{name}/bin/mbpath
%{_libdir}/%{name}/bin/notifyd
%{_libdir}/%{name}/bin/pop3d
%{_libdir}/%{name}/bin/pop3proxyd
%{_libdir}/%{name}/bin/quota
%{_libdir}/%{name}/bin/reconstruct
%{_libdir}/%{name}/bin/sievec
%{_libdir}/%{name}/bin/smmapd
%{_libdir}/%{name}/bin/squatter
%{_libdir}/%{name}/bin/timsieved
%{_libdir}/%{name}/bin/tls_prune
%{_bindir}/*
%{_libdir}/perl?/site_perl/*/*/auto/Cyrus
%{_libdir}/perl?/site_perl/*/*/Cyrus
%{_mandir}/*/*
%attr(750,cyrus,mail) /var/spool/cyrus-imap

%files devel
%defattr(-,root,root,0755)
%{_libdir}/*.a
%{_includedir}/cyrus

%changelog
* Tue May 31 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2.2.12-3tr
- Changed chkconfig of cyrus to 76 24

* Fri Apr 22 2005 Ajith Thampi <ajith at comodo dot com> 2.2.12-2tr
- Rebuilt with postgresql-8.0.2

* Thu Feb 24 2005 Erlend Midttun <erlendbm at trustix dot org> 2.2.12-1tr
- New upstream.

* Fri Feb 18 2005 Erlend Midttun <erlendbm at trustix dot org> 2.2.10-3tr
- Rename "master" to "cyrus-master".  Bug #70.

* Fri Jan 14 2005 Ivan Brunello <ivan.brunello@aonetinternational.it> 2.2.10-2ib
- added autocreate patch from email.uoa.gr

* Wed Nov 24 2004 Erlend Midttun <erlendbm at trustix dot org> 2.2.10-1tr
- New upstream.

* Tue Nov  9 2004 Oystein Viggen <oysteivi at trustix dot com> 2.2.8-2tr
- Rebuild with shared openssl

* Mon May 24 2004 Erlend Midttun <erlendbm at trustix dot org> 2.2.3-3tr
- Added sieve directories.

* Wed Apr 28 2004 Erlend Midttun <erlendbm at trustix dot org> 2.2.3-2tr
- Fixed ctl_deliver -> cyr-expire in cron job.
- Fixed libdir.

* Thu Mar 11 2004 Oystein Viggen <oysteivi at trustix dot com> 2.2.3-1tr
- New upstream version

* Tue Feb  3 2004 Chr. Toldnes <christht at trustix dot org> 2.1.16-3tr
- Fix errors during build

* Thu Dec 11 2003 Erlend Midttun <erlendbm at trustix dot org> 2.1.16-2tr
- Rebuilt.

* Thu Nov 20 2003 Tor Hveem <torh at trustix dot org> 2.1.16-1th
- New upstream version

* Wed Sep 17 2003 Chr. Toldnes <christht at trustix dot com> 2.1.15-3tr
- Rebuilt and retagged for release.

* Tue Sep 16 2003 Chr. Toldnes <christht at trustix dot com> 2.1.15-1tr
- New upstream version: 2.1.15

* Fri Jul 18 2003 Chr. Toldnes <christht at trustix dot com> 2.1.14-3tr
- Rebuilt and tagged for TSL 2.0

* Wed Jul 16 2003 Gerald Dachs <gda at trustix dot org> 2.1.14-2gd
- corrected perl path

* Wed Jul 16 2003 Gerald Dachs <gda at trustix dot org> 2.1.14-1gd
- new upstream version

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 2.1.13-11tr
- Added %defattr.

* Fri Jun 20 2003 Chr. Toldnes <christht at trustix dot com> 2.1.13-10tr
- Minor fix in initscript.

* Fri Jun 20 2003 Chr. Toldnes <christht at trustix dot com> 2.1.13-9tr
- Correct placement of internal binaries.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 2.1.13-8tr
- Big rebuild

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 2.1.13-7em
- We leave logrotate to syslog.

* Mon Jun 16 2003 Chr. Toldnes <christht at trustix dot com> 2.1.13-6ct
- logrotate config corresponds with syslog setup

* Fri Jun 13 2003 Chr. Toldnes <christht at trustix dot com> 2.1.13-5ct
- Minor fix in the cron script to use /var/lib/cyrus-imapd

* Wed Jun 11 2003 Chr. Toldnes <christht at trustix dot com> 2.1.13-4ct
- Huge cleanups.

* Wed Jun  4 2003 Erlend Midttun <erlendbm at trustix dot com> 2.1.13-3em
- init script now uses killproc.

* Mon May 19 2003 Tor Hveem <torh at trustix dot org> 2.1.13-2th
- Fixed wrong socket path in cyrus.conf

* Mon May 19 2003 Tor Hveem <torh at trustix dot org> 2.1.13-1th
- Improved imapd.conf
- 2.1.13
- Changed paths to /var/spool/cyrus-imapd
- Removed not needed file /usr/lib/sasl2/Cyrus.conf
- Added missing BuildReq perl-devel

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 2.1.12-4em
- Rebuilt against glibc 2.3.2.

* Mon Mar 10 2003 Christian H. Toldnes <christht at trustix dot com> 2.1.12-3ct
- Package somehow required /usr/local/bin/perl patch3 fixed this.
- No need to use both autoconf and %configure in my opinion. I stand 'till 
  proven wrong. :)

* Sun Mar 09 2003 Tor Hveem <torh at trustix dot org> 2.1.12-2th
- added som missing items
- removed %config for a few files
- added noreplace for a few files

* Tue Feb 04 2003 Tor Hveem <torh at trustix dot org> 2.1.12-1th
- 2.1.12
- initscript now uses cyrus' own .pid file

* Mon Jan 06 2003 Tor Hveem <tor at trustix dot org> 2.1.11-4th
- added missing buildreq openssl-devel
- added --with-annotatemore and --with-listext 
- added a few more missing manpages and binaries
- new package: devel

* Fri Dec 20 2002 Tor Hveem <torh at trustix dot org> 2.1.11-3th
- added missing ctl_cyrusdb binary
- added missing ctl_cyrusdb manpage

* Thu Dec 19 2002 Gerald Dachs <gda at trustix dot org> 2.1.11-2gd
- use now killbypidfile in initscript
- updated cyrus.conf file

* Wed Dec 18 2002 Gerald Dachs <gda at trustix dot org> 2.1.11-1gd
- new upstream version
- fixed location of pidof in init script
- changed invokation of functions in init script
- don't use %config for cyrus init script anymore
- changed lockdev to .lockdev in cyrus init script

* Thu Nov 21 2002 Christian H. Toldnes <christht at trustix dot com> 2.1.7-5ct
- cyrus initscript now uses $INITLOCK

* Wed Nov 20 2002 Erlend Midttun <erlendbm at trustix dot com> 2.1.7-4em
- Split the PAM files into a separate package and Req'ed them.
- Added Provides imapd.
- Removed Conflicts as it is no longer needed.

* Fri Nov  8 2002 Erlend Midttun <erlendbm at trustix dot com> 2.1.7-3em
- Updated Conflicts and renamed man pages to avoid crashing there.

* Thu Sep 12 2002 Erlend Midttun <erlendbm at trustix dot com> 2.1.7-2em
- Use autoconf to create new configure.
- Use configure macro
- Require autoconf >= 2.52.  Does not work with 2.13 at least.
- PreReq shadow-utils and glibc as they are in %pre

* Thu Aug 22 2002 Gerald Dachs <gda at trustix dot org> 2.1.7-1gd
- new version 2.1.7
- depends now on db4
- deactivated install of postfix config files
  should not be done here

* Mon Aug  5 2002 Christian H. Toldnes <christht at trustix dot com> 2.1.4-3ct
- The build environment does not need cyrus user and mail group.
- uid 103 belongs to ntp. cyrus got 110 for now.
- cyrus-imap.rc now looks in /etc/init.d for functions file.
- Added chkconfig and restart_maybe in %post
- Removed condrestart in %postun, as we restart in %post

* Fri Aug  2 2002 Gerald Dachs <gda at trustix dot org> 2.1.4-2gd
- cleaned up group
- better user management
- don't start cyrus by default

* Mon Jun 10 2002 Gerald Dachs <gda at trustix dot org> 2.1.4-1gd
- repackaged for Trustix
- new version 2.1.4

* Sat Sep 15 2001 Gerald Dachs <gda@dachsweb.de>
- cyrus-imapd.cron changed deliver to ctl_deliver

* Fri Apr 13 2001 Gerald Dachs <gda@dachsweb.de>
- Postfix support
- pwcheck_method is now PAM
- changed cyrus-imapd-rc, pidof is in /bin
- created sieve user directories

